#!/usr/bin/python

from mplcore.api import *
from mpl_web import Search
from cgi import parse_qs
from ssx import SSXRedirect

class CGIVendor(Vendor):
	def __init__(self, qs = None):
		self.qs = qs
		self.vendor = self.get("vendor")
		self.name = self.get("name")
		self.misc = self.get("misc")
		self.action = self.get("action")
		self.discount = self.get("discount")
		try:
			self.discount = (100 - float(self.discount)) / 100
		except:
			self.discount = "NULL" 
		if self.action == None:
			self.action = "init"

	def get(self, what, default = None):
		try:
			return self.qs[what][0]
		except Exception,e:
			return default
def handler(req, xml, conf):
	if (req.args == None):
		cgi = None
	else:
		cgi = parse_qs(req.args, keep_blank_values = True, strict_parsing = True)
	sr = Search(cgi)
	cv = CGIVendor(cgi)

	mpl = MPL(conf = conf)

	if cv.action == "init":
		xml.data("<ssx:title>MPL: Редактирование производителя</ssx:title>\n")
		xml.push("mpl:vendors", "mode='edit'")
		xml.data("\n".join(map (lambda x: x.xml(), mpl.vendor(id = sr.vendor))))
		xml.pop("mpl:vendors")
		return
	elif cv.action == "add":
		v = Vendor()
		v.id = "add"
		v.name = "Название организации"
		v.misc = "Реквизиты"
		xml.push("mpl:vendors", "mode='edit'")
		xml.data(v.xml())
		xml.pop("mpl:vendors")
		return
	elif cv.action == "delete":
		mpl.vendor_delete(int(cv.vendor))
		raise SSXRedirect("vendor.py")
	elif cv.action == "edit":
		if cv.vendor == "add":
			cv.id = 0
			cv.id = mpl.vendor_add(cv)
		else:
			cv.id = int(cv.vendor)
			mpl.vendor_update(cv)
		raise SSXRedirect("vendor.py?vendor=%s" % cv.id)

	#xml.data("<mpl:search action='search.py'>фильм</mpl:search>\n")
	xml.data("<ssx:title>MPL: Редактирование производителя</ssx:title>\n")


	#vendor = None
	#if sr.vendor != None:
	#	vl = mpl.vendor(id = sr.vendor)
